<a id="mypy-boto3-emr-containers"></a>

# mypy-boto3-emr-containers

[![PyPI - types-aiobotocore-emr-containers](https://img.shields.io/pypi/v/types-aiobotocore-emr-containers.svg?color=blue)](https://pypi.org/project/types-aiobotocore-emr-containers)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-emr-containers.svg?color=blue)](https://pypi.org/project/types-aiobotocore-emr-containers)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-emr-containers?color=blue)](https://pypistats.org/packages/types-aiobotocore-emr-containers)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.EMRContainers 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/emr-containers.html#EMRContainers)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-emr-containers docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_emr_containers/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-emr-containers](#mypy-boto3-emr-containers)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `EMRContainers`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `EMRContainers` service.

```bash
python -m pip install types-aiobotocore[emr-containers]
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[emr-containers]` in your environment:
  `python -m pip install 'types-aiobotocore[emr-containers]'`

Both type checking and auto-complete should work for `EMRContainers` service.
No explicit type annotations required, write your `boto3` code as usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[emr-containers]` in your environment:
  `python -m pip install 'types-aiobotocore[emr-containers]'`

Both type checking and auto-complete should work for `EMRContainers` service.
No explicit type annotations required, write your `aiobotocore` code as usual.
Auto-complete can be slow on big projects or if you have a lot of installed
`types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[emr-containers]` in your environment:
  `python -m pip install 'types-aiobotocore[emr-containers]'`
- Run `mypy` as usual

Type checking should work for `EMRContainers` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[emr-containers]` in your environment:
  `python -m pip install 'types-aiobotocore[emr-containers]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `EMRContainers` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`EMRContainersClient` provides annotations for
`session.create_client("emr-containers")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_emr_containers import EMRContainersClient

session = get_session()
with async session.create_client("emr-containers") as client:
    client: EMRContainersClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_emr_containers.paginator` module contains type annotations
for all paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_emr_containers import EMRContainersClient
from types_aiobotocore_emr_containers.paginator import (
    ListJobRunsPaginator,
    ListManagedEndpointsPaginator,
    ListVirtualClustersPaginator,
)

session = get_session()
with async session.create_client("emr-containers") as client:
    client: EMRContainersClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        list_job_runs_paginator: ListJobRunsPaginator = client.get_paginator("list_job_runs")
        list_managed_endpoints_paginator: ListManagedEndpointsPaginator = client.get_paginator("list_managed_endpoints")
        list_virtual_clusters_paginator: ListVirtualClustersPaginator = client.get_paginator("list_virtual_clusters")
    ```







### Literals

`types_aiobotocore_emr_containers.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_emr_containers.literals import (
    ContainerProviderTypeType,
    EndpointStateType,
    FailureReasonType,
    JobRunStateType,
    ListJobRunsPaginatorName,
    ListManagedEndpointsPaginatorName,
    ListVirtualClustersPaginatorName,
    PersistentAppUIType,
    VirtualClusterStateType,
    ServiceName,
    PaginatorName,
)

def check_value(value: ContainerProviderTypeType) -> bool:
    ...
````

### Typed dictionaries

`types_aiobotocore_emr_containers.type_defs` module contains structures and
shapes assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_emr_containers.type_defs import (
    CancelJobRunRequestRequestTypeDef,
    CancelJobRunResponseTypeDef,
    CertificateTypeDef,
    CloudWatchMonitoringConfigurationTypeDef,
    ConfigurationOverridesTypeDef,
    ConfigurationTypeDef,
    ContainerInfoTypeDef,
    ContainerProviderTypeDef,
    CreateManagedEndpointRequestRequestTypeDef,
    CreateManagedEndpointResponseTypeDef,
    CreateVirtualClusterRequestRequestTypeDef,
    CreateVirtualClusterResponseTypeDef,
    DeleteManagedEndpointRequestRequestTypeDef,
    DeleteManagedEndpointResponseTypeDef,
    DeleteVirtualClusterRequestRequestTypeDef,
    DeleteVirtualClusterResponseTypeDef,
    DescribeJobRunRequestRequestTypeDef,
    DescribeJobRunResponseTypeDef,
    DescribeManagedEndpointRequestRequestTypeDef,
    DescribeManagedEndpointResponseTypeDef,
    DescribeVirtualClusterRequestRequestTypeDef,
    DescribeVirtualClusterResponseTypeDef,
    EksInfoTypeDef,
    EndpointTypeDef,
    JobDriverTypeDef,
    JobRunTypeDef,
    ListJobRunsRequestRequestTypeDef,
    ListJobRunsResponseTypeDef,
    ListManagedEndpointsRequestRequestTypeDef,
    ListManagedEndpointsResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    ListVirtualClustersRequestRequestTypeDef,
    ListVirtualClustersResponseTypeDef,
    MonitoringConfigurationTypeDef,
    PaginatorConfigTypeDef,
    ResponseMetadataTypeDef,
    S3MonitoringConfigurationTypeDef,
    SparkSubmitJobDriverTypeDef,
    StartJobRunRequestRequestTypeDef,
    StartJobRunResponseTypeDef,
    TagResourceRequestRequestTypeDef,
    UntagResourceRequestRequestTypeDef,
    VirtualClusterTypeDef,
)

def get_structure() -> CancelJobRunRequestRequestTypeDef:
    return {
      ...
    }
```

## Versioning

`types-aiobotocore-emr-containers` version is the same as related `boto3`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

## Documentation

All type annotations can be found in
[types-aiobotocore-emr-containers docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_emr_containers/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
